#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <graphics.h>

void forgatas(palettetype *Palette)
{
    //eltolja a Palette.colors[] tömb elemeit eggyel balra

    int d, i;
    d = Palette->colors[1];

    for (i = 1; i < 15; i++)
      Palette->colors[i - 1] = Palette->colors[i];

    Palette->colors[15] = d;
}

int main()
{
    unsigned int Color, StAngle, EndAngle;
    palettetype Palette, OldPalette;

    initwindow(640, 480);

    getpalette(&Palette);
    OldPalette = Palette;

    srand(time(NULL));
    int i;
    for (i = 0; i < 15; i++)
        Palette.colors[i] = rand() % 64;

    circle(getmaxx() / 2, getmaxy() / 2, getmaxy() / 4);

    for (Color = 0; Color < 15; Color++)
    {
        StAngle = (360 / 15) * Color;
        EndAngle = (360 / 15) * (Color + 1);
        setfillstyle(SOLID_FILL, Color);
        pieslice(getmaxx() / 2, getmaxy() / 2, StAngle, EndAngle, getmaxy() / 4);
    }
    getchar();

    /* A paletta forgatása csak Borland C/C++ alatt működik sajnos */

    setallpalette(&Palette);
    for (i = 300; i > 0; i -= 5)
    {
        forgatas(&Palette);
        delay(i);
        setallpalette(&Palette);
    }

    for (i = 0; i <= 300; i += 5)
    {
        forgatas(&Palette);
        delay(i);
        setallpalette(&Palette);
    }

    setallpalette(&OldPalette);
    getch();
    closegraph();
    return 0;
}
